package org.netkernel.module.standard.builtin;

import org.netkernel.layer0.meta.IPrototypeParameterMeta;
import org.netkernel.layer0.meta.impl.DefaultPrototypeMeta;
import org.netkernel.layer0.meta.impl.PrototypeParameterMetaImpl;
import org.netkernel.module.standard.endpoint.StandardMonoEndpointImpl;
import org.w3c.dom.Element;

public class StaticResourcePrototype extends DefaultPrototypeMeta
{
	public static final String PARAM_GLOB="glob";
	public static final String PARAM_REGEX="regex";
	public static final String PARAM_REWRITE="rewrite";
	public static final String PARAM_GRAMMAR="grammar";
	
	public static IPrototypeParameterMeta[] sPrototypeParameters = new IPrototypeParameterMeta[]
    {	
    	StandardMonoEndpointImpl.sPrototypeParameters[0],
    	StandardMonoEndpointImpl.sPrototypeParameters[1],
    	StandardMonoEndpointImpl.sPrototypeParameters[2],
    	StandardMonoEndpointImpl.sPrototypeParameters[3],
    	StandardMonoEndpointImpl.sPrototypeParameters[4],
    	StandardMonoEndpointImpl.sPrototypeParameters[5],
		new PrototypeParameterMetaImpl(PARAM_GLOB,"Glob expression defining exposed resources", String.class,null),
		new PrototypeParameterMetaImpl(PARAM_REGEX,"Regex expression defining exposed resources", String.class,null),
		new PrototypeParameterMetaImpl(PARAM_REWRITE,"Rewrite expression, can be used with regex", String.class,null),
		new PrototypeParameterMetaImpl(PARAM_GRAMMAR,"Grammar expression defining exposed resources", Element.class,null)
  	};
	
	public StaticResourcePrototype()
	{	super(StaticResourceEndpoint.class,"ModuleResource");
	}

	public IPrototypeParameterMeta[] getParameters()
	{	return sPrototypeParameters;
	}

	public String getDescription()
	{	return "provides access to resources with the modules filesystem";
	}

	public String getName()
	{	return "Module Resource Endpoint";
	}
}