package org.netkernel.module.standard.builtin.mapper;

import java.io.InputStream;
import java.lang.reflect.Method;

import org.netkernel.container.IKernel;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.layer0.util.Utils;
import org.netkernel.layer0.util.XMLUtils;
import org.netkernel.module.standard.StandardSpace;
import org.netkernel.module.standard.endpoint.ConfiguredOverlayImpl;
import org.netkernel.urii.IIdentifier;
import org.netkernel.urii.ISpace;
import org.w3c.dom.Document;

/**
 * MapperOverlay
 * @author  tab
 */
public class MapperOverlay extends ConfiguredOverlayImpl
{
	public MapperOverlay()
	{	declareThreadSafe();
		declareParameters(MapperPrototype.sPrototypeParameters);
		declareUnhandledExceptionsExpired(false);

	}
	
	protected IConfig createConfig(INKFRequestContext aContext) throws Exception
	{
		Document d=Utils.sourceAsDOMAvoidingTransrept(aContext, "param:config");
		Object configVal=aContext.getParamValue("config");
		if (configVal instanceof IIdentifier)
		{	aContext.setCWU(configVal.toString());
		}
		IConfig config = new MapperConfig(d,getDelegateSpace(),getDelegateMeta(aContext), aContext, this);
		return config;
	}
	
	protected void destroyConfig(IConfig aConfig) throws Exception
	{
	}

	public String getName()
	{	return toString();
	}
	
	public IKernel getKernel()
	{	return super.getKernel();
	}
	
	StandardSpace getOwningSpace()
	{	return (StandardSpace)super.getSpace();
	}
}