package org.netkernel.module.standard.endpoint;

import org.netkernel.container.IKernel;
import org.netkernel.layer0.meta.IPrototypeParameterMeta;
import org.netkernel.layer0.nkf.INKFLocale;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.impl.NKFContextImpl;
import org.netkernel.layer0.nkf.impl.NKFTransportContextImpl;
import org.netkernel.module.standard.StandardSpace;
import org.netkernel.request.IRequestScopeLevel;
import org.netkernel.urii.ISpace;


public abstract class StandardTransportImpl extends StandardAccessorImpl
{
	protected INKFRequestContext mContext;
	
	public void onCommissionEndpoint(IKernel aKernel, ISpace aSpace) throws Exception
	{	super.onCommissionEndpoint(aKernel, aSpace);
		if (mMeta.getSupportedVerbs()==0)
		{	mId=null;
		}
	}
	
	/** This is the context that should be used by the transport for all regular requests outside
	 * the lifecycle events of postCommission and preDecommission 
	 * @return
	 */
	public INKFRequestContext getTransportContext()
	{	return mContext;
	}
	
	public void preDecommissionMapping(IRequestScopeLevel aStaticScope) throws Exception
	{	// tell kernel to interrupt any pending blocked requests for this transport 
		getKernel().interruptExternalRequests(this);
		
		super.preDecommissionMapping(aStaticScope);
	}

	void doPostCommission(INKFRequestContext aContext) throws Exception
	{	mContext = new NKFTransportContextImpl(getKernel(),getSpace(),this,getParameters(),aContext.getKernelContext().getRequestScope());
		postCommission(aContext);
	}
	
	protected abstract void postCommission(INKFRequestContext aContext) throws Exception;
	
	protected abstract void preDecommission(INKFRequestContext aContext) throws Exception;

}
